﻿
function OnMouseOver(obj)
{
    if(obj.style.backgroundColor != 'blue')
    {
        obj.className = 'recordHover';
    }
}

function OnMouseOut(obj, orgClass)
{
    if(obj.style.backgroundColor != 'blue')
    {
        obj.className = orgClass;
    }
}

//Enable/disable all controls within the specified element 
function DisableDivElements(divTag, disable)
{
    if (divTag.type != null)
    {
        divTag.disabled = disable;
    }

    for (var i = 0; i < divTag.childNodes.length; i++)
    {
        var childDivTag = divTag.childNodes[i];

        if (childDivTag.childNodes.length != 0)
        {
            DisableDivElements(childDivTag, disable);
        }
        else
        {
            if (childDivTag.type != null)
            {
                childDivTag.disabled = disable;
            }
        }
    }
}

//Display/hide wait image
function DisplayWait(bool)
{
    if(bool == 1)
    {
        var clientWidth = document.documentElement.clientWidth;
        var clientHeight = document.documentElement.clientHeight;
        var scrollLeft = document.documentElement.scrollLeft;
        var scrollTop = document.documentElement.scrollTop;
        
        var obj = document.getElementById('div_wait');
        
        if(clientWidth > 652)
        {
            obj.style.left = '300px';
        }
        else
        {
            obj.style.left = (clientWidth / 2 + scrollLeft - 33).toString() + 'px';
        }

        if(clientHeight > 500)
        {
            obj.style.top = '300px';
        }
       else
        {
            obj.style.top = (clientHeight / 2 + scrollTop - 33).toString() + 'px';
        }
        
        document.getElementById('div_wait').style.display = 'block';
    }
    else
    {
        document.getElementById('div_wait').style.display = 'none';
    }
}

function GetCurrentDate()
{
    var d = new Date();

    var date = d.getDate();
    var month = d.getMonth() + 1;
    var year = d.getFullYear();
    
    if (date < 10) { date = '0' + date; }
    if (month < 10) { month = '0' + month; }

    return date + '-' + month + '-' + year;
}

function GetCurrentTime()
{
    var d = new Date();

    var hour = d.getHours();
    var minutes = d.getMinutes();

    if (hour < 10) { hour = '0' + hour; }
    if (minutes < 10) { minutes = '0' + minutes; }
    
    return hour + ':' + minutes;
}

function DateOK(date)
{
    var error = 'Ikke korrekt dato format!\nDato skal være på formen: DD-MM-ÅÅÅÅ\nF.eks: 21-02-2004';

    if(date.length != 10)
    {
        alert(error);
        return false;
    }
    
    if((date.substr(2,1) != '-') || (date.substr(5,1) != '-'))
    {
        alert(error);
        return false;
    }
    
    var day;
    var month;
    var year;
    
    try
    {
        day = parseInt(date.substr(0, 2), 10);
        month = parseInt(date.substr(3, 2), 10);
        year = parseInt(date.substr(6, 4), 10);
    }
    catch(err) 
    {
        alert(error);
        return false;
    }
    
    if((isNaN(day)) || (isNaN(month)) || (isNaN(year)))
    {
        alert(error);
        return false;
    }
    
    if((day > 31) || (month > 12) || (year < 1970))
    {
        alert(error);
        return false;
    }        
    
    return true;
}

function IsTime(input)
{
    if (input.length != 5)
        return false;

    if (input.charAt(2) != ':')
        return false;

    var hour1 = input.substring(0, 1);
    var hour2 = input.substring(1, 2);
    var min1 = input.substring(3, 4);
    var min2 = input.substring(4, 5);

    var numbers = '0123456789';

    if (numbers.substring(0, 3).indexOf(hour1) == -1)
        return false;

    if (numbers.indexOf(hour2) == -1)
        return false;

    if (numbers.substring(0, 6).indexOf(min1) == -1)
        return false;

    if (numbers.indexOf(min2) == -1)
        return false;

    var hour = parseInt(input.substring(0, 2), 10);
    var min = parseInt(input.substring(3, 5), 10);

    if ((hour > 23) || (min > 59))
        return false;

    return true;
}

function TimeOK(time)
{
    if (!IsTime(time))
    {
        alert('Ikke korrekt tid format!\nTid skal være på formen: HH:mm\nF.eks: 14:30');
        return false;
    }

    return true;
}

function IsInteger(input)
{
    if(input.length == 0)
    {
        return false;
    }

    var ValidChars = "0123456789";
    var IsInteger = true;
    var Char;

    for (var i = 0; i < input.length && IsInteger == true; i++) 
    { 
        Char = input.charAt(i);
         
        if (ValidChars.indexOf(Char) == -1) 
        {
            IsInteger = false;
        }
    }
    
    return IsInteger;
}

function IsDouble(input)
{
    if(input.length == 0)
    {
        return false;
    }

    var ValidChars = "0123456789,";
    var IsDouble = true;
    var Char;
    var noOfKomma = 0;

    for (var i = 0; i < input.length && IsDouble == true; i++) 
    { 
        Char = input.charAt(i);
        
        if(Char == ',')
        {
            if(++noOfKomma > 1)
            {
                IsDouble = false;                
            }
        }
         
        if (ValidChars.indexOf(Char) == -1) 
        {
            IsDouble = false;
        }
    }
    
    if(noOfKomma != 0)
    {
        var array = new Array();
        array = input.split(',');

        if ((array[1].length != 1) && (array[1].length != 2))
        {
            IsDouble = false;
        }
    }
    
    return IsDouble;
}

function findPos(obj)
{
    var curleft = curtop = 0;
    if (obj.offsetParent)
    {
        do
        {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        } while (obj = obj.offsetParent);
    }
    
    return [curleft,curtop];
}

Date.prototype.addDays = function(days)
{
    this.setDate(this.getDate() + days);
}

function GetFormatedDate(d)
{
    var day = d.getDate();
    var month = d.getMonth() + 1;
    var year = d.getFullYear();
    
    if(day < 10) { day = '0' + day; }
    if(month < 10) { month = '0' + month; }
    return day + '-' + month + '-' + year;
}

function IntelligentDate(obj)
{
    var text = obj.value;
    var d = new Date();

    if((text.length < 3) && (IsInteger(text)))
    {
        d.setDate(parseInt(obj.value, 10));
        obj.value = GetFormatedDate(d);
        return;
    }

    if ((text.length == 4) && (IsInteger(text)))
    {
        d.setMonth(parseInt(text.substr(2, 2), 10) - 1, parseInt(text.substr(0, 2), 10));
        obj.value = GetFormatedDate(d);
        return;
    }

    if((text.length == 6) && (IsInteger(text)))
    {
        d.setFullYear(parseInt('20' + text.substr(4, 2), 10), parseInt(text.substr(2, 2), 10) - 1, parseInt(text.substr(0, 2), 10));
        obj.value = GetFormatedDate(d);
        return;
    }
    
    if(text.length < 2)
    {
        return;
    }
    
    if((text.length == 8) && (IsInteger(text)))
    {
        d.setFullYear(parseInt(text.substr(4, 4), 10), parseInt(text.substr(2, 2), 10) - 1, parseInt(text.substr(0, 2), 10));
        obj.value = GetFormatedDate(d);
    
        return;
    }
    
    if(text.substr(0, 2).toLowerCase() == 'dd')
    {
        if(text.length == 2)
        {
            obj.value = GetFormatedDate(d);
        }
        else if((text.length > 3) && ((text.substr(2, 1) == '+') || (text.substr(2, 1) == '-')) && (IsInteger(text.substr(3))))
        {
            d.addDays(parseInt(text.substr(2), 10));
            obj.value = GetFormatedDate(d);
        }
    }
}

function OnKeyDown(e)
{
    if(e.keyCode == 27)
    {
        e.returnValue = false;
        e.cancel = true;
    
        CloseAllWindows();        
    }
}

function CreateDotRepresentation(number)
{
    var output = '';
    var pos = 0;
    
    for(var i = number.length - 1; i >= 0; i--)
    {
        output = number[i] + output;
        
        if((pos % 3 == 2) && (i > 0))
            output = '.' + output;
            
        pos++;
    }
    
    return output;
}

